color col_red = color(240, 0, 0);
color col_green = color(50, 250, 50);

class TreeNode {
  PVector pos;
  float psize; //diameter
  color fillCol = color(255);
  char data;

  TreeNode left, right;

  TreeNode(int x, int y) {
    this.data = char(int(random('A','Z'+1)));
    pos = new PVector(x, y);
    psize = 20;
  }

  void display() {
    //draw lines to left and right
    float OFFSET = 3;
    if (left != null) {
      stroke(col_red);
      line(pos.x - OFFSET, pos.y - 0, left.pos.x - OFFSET, left.pos.y - 0);
    }
    if (right != null) {
      stroke(col_green);
      line(pos.x + OFFSET, pos.y + 0, right.pos.x + OFFSET, right.pos.y + 0);
    }
    
    // Draw Circle
    stroke(0);
    fill(fillCol);
    circle(pos.x, pos.y, psize);
    
    // Write Text
    textAlign(CENTER,CENTER);
    fill(color(0));
    textSize(16);
    text(data, pos.x, pos.y-2);
  }
}
